#!/usr/bin/python                                                                                                                                                                                                               
                                                                                                                                                                                                                                
from PyTango import *                                                                                                                                                                                                           
import sys                                                                                                                                                                                                                      
import time                                                                                                                                                                                                                     
import re                                                                                                                                                                                                                                

if len(sys.argv) > 1:
	lineCnt = 0;
	f = file(sys.argv[1], 'r')
	outfilename = sys.argv[0] + '.log'
	fout = file(outfilename, 'w')
	lines = f.readlines()

	# the following two store the devices already having/not having helperApplication property set.
	devsWithHelperAppProp = []
	devsWithoutHelperAppProp = []

	# the following three lines are used to buffer log messages
	errorLine = []
	propSetLine = []
	propUnsetLine = []

	# dictionary of couples device/property
	devPropDict = {}
	errCnt = 0;

	do_apply = 0

	if '--apply' in sys.argv:
		do_apply = 1

	# This dictionary stores the properties that would be set (from file) if the device 
	# did not already have helperApplication configured.
	wouldPropDict = {} 
	for line in lines:
		lineCnt = lineCnt + 1
		line.replace('\n', '')

		if line.find('#') < 0 and len(line) > len(" <--> ") + 2 :
			parts = line.split(" <--> ")
			if len(parts) != 2:
				print '\033[1;31m*\033[0m Error: line ', line, ' in file ', sys.argv[1], 'does not contain \" <--> \" separator (exactly with spaces)\n'
				sys.exit(1)

			device = parts[0]
			device = device.replace(' ', '')
			validDev = re.search("[a-zA-Z0-9\._\-]+/[a-zA-Z0-9\._\-]+/[a-zA-Z0-9\._\-]+", device)
			if validDev != None:
				helperApp = parts[1]
				helperApp = helperApp.replace('\n', '')
#				helperApp = helperApp.replace(' ','')
				try:
					dev = DeviceProxy(device)
					helperAppProperty = dev.get_property_list("helperApplication")
					# if no helperApplication property set:
					if len(helperAppProperty) == 0: 
						devsWithoutHelperAppProp.append(device) 
						devPropDict[device] = helperApp # save the helper app read from file
					else:
						devsWithHelperAppProp.append(device)
						devPropDict[device] = dev.get_property('helperApplication')['helperApplication'][0]
						wouldPropDict[device] = helperApp

				except DevFailed, e:
					errCnt = errCnt + 1
					print '\033[1;31mError connecting to device\033[0m \"',device,'\":\n', Except.print_exception(e)
					errorLine.append('Error connecting to device \"' + device + '\"\n' )
			else:
				print '\033[1;31m device ', device, '\033[0m in line ', line, ' is not a valid tango device name'
	for deviceWithout in devsWithoutHelperAppProp:
		if do_apply == 0:
			print '\033[1;32m+\033[0m \033[1;4;35mwould\033[0m set helperApplication to \"' + devPropDict[deviceWithout] + '\" on \"'  + deviceWithout + '\" (\"\033[0;32m--apply\033[0m\" was not specified on the command line)'
			# write on log file
			propUnsetLine.append('helperApplication \"'  + devPropDict[deviceWithout] + '\" on \"'  + deviceWithout + '\" not set because \"--apply\" was not specified on the command line\n')

		else:

			print '\033[1;32m+\033[0m setting helperApplication to \"' + devPropDict[deviceWithout] + '\" on \"'  + deviceWithout + '\"'
			try:
				device = DeviceProxy(deviceWithout)
				dbdatum = DbDatum()
				dbdatum.name = 'helperApplication'
				dbdatum.append(devPropDict[deviceWithout])
				device.put_property(dbdatum)
				propSetLine.append('correctly set helperApplication  \"' + devPropDict[deviceWithout] + '\" on \"'  + deviceWithout + '\"\n')                                        

			except DevFailed, e:
				errCnt = errCnt + 1
				print '\033[1;31m*\033[0m error setting property \"' + devPropDict[deviceWithout] + '\" on \"' + deviceWithout + '\".'
				errorLine.append('Error setting property on device \"' + device + '\"\n' )

	for deviceWith in devsWithHelperAppProp:
		print '\033[1;35m*\033[0m would not set helperApplication \"' + wouldPropDict[deviceWith] + '\" on \"' + deviceWith + '\"'
		print '  because it already has the property already set to \"' + devPropDict[deviceWith] + '\".'
		# write on the log file
		propUnsetLine.append('helperApplication \"' + wouldPropDict[deviceWith] + '\" on \"' + deviceWith + '\" has not been set because the device already has it set to  \"' + devPropDict[deviceWith] + '\".\n')
	
	unchangedCnt = len(devsWithHelperAppProp)
	changedCnt = len(devsWithoutHelperAppProp)

	fout.write(sys.argv[0] + ' log file saved on ' + time.ctime() + '\n')
	fout.write('\nProperties set:\n\n')
	for set in propSetLine:
		fout.write(set)
	fout.write('\nProperties not set:\n\n')
	for unset in propUnsetLine:
		fout.write(unset)
	fout.write('\nErrors:\n\n')
	for err in errorLine:
		fout.write(err)


	print '' 
	print '\033[1;32m*\033[0m execution ended with ', errCnt,  ' errors, ', changedCnt , ' properties set and ', unchangedCnt , ' properties unset.'
	print '\033[1;32m*\033[0m log saved on \"' + outfilename + '\".\n'		

else:
	print '\n\033[1;4;37mUsage\033[0m: ', sys.argv[0], ' input_filename.'
	print '\n        \033[1;4;37moptions\033[0m: --apply: write helperApplication properties on tango database.'
	print '                 if \033[1;37;4mnot set\033[0m, no write is done on the database.'
	print '\nAn output file named \"' + sys.argv[0] + '.log\" will be saved on current directory.\n'
	sys.exit(1)

sys.exit(0)

	

